<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 2.3: Constants</title>
<link href="sx5b.html" rev=precedes>
<link href="sx5d.html" rel=precedes>
<link href="sx5.html" rev=subdocument>
</head>
<body>
<H2>section 2.3: Constants</H2>

page 37
<p>We write constants in decimal, octal, or hexadecimal
for our convenience,
not the compiler's.
The compiler doesn't care;
it always converts everything into binary internally, anyway.
(There is, however,
no good way to specify constants in source code in binary.)
</p><p>pages 37-38
</p><p>Read the descriptions of character and string constants carefully;
most C programs work with these data types a lot,
and their proper use must be kept in mind.
Note particularly these facts:
</p><OL><li>The character constant <TT>'x'</TT> is quite different from
the string constant <TT>"x"</TT>.
<li>The value of a character is simply
``the numeric value of the character in the machine's character set.''

<li>Strings are terminated by the null character, <TT>\0</TT>.
(This applies to both string constants and to all other strings 
we'll build and manipulate.)
This means that the size of a string
(the number of <TT>char</TT>'s worth of memory it occupies)
is always one more than its length
(i.e. as reported by <TT>strlen</TT>)
appears to be.
</OL><p>As we saw in section 1.6 on page 23,
it's possible to switch rather freely between thinking of a 
character as a character and thinking of it as its value.
For example, the <em>character</em> <TT>'0'</TT>
(that is,
the character that can print on your screen
and looks like the number zero)
has in the ASCII character set the internal <em>value</em> 48.
Another way of saying this is to notice that the following 
expressions are all true:
<pre>	'0' == 48
	'0' == '\060'
	'0' == '\x30'
</pre>We'll have a bit more to say about characters
and their small integer representations
in section 2.7.
</p><p>Note also that the <em>string</em> <TT>"48"</TT> consists of the 
three characters <TT>'4'</TT>, <TT>'8'</TT>, and <TT>'\0'</TT>.
Also in section 2.7
we'll meet the <TT>atoi</TT> function
which computes a numeric value from a string of digits like this.
</p><p>page 39
</p><p>We won't be using enumerations,
so you don't have to worry too much about the description of 
enumeration constants.
</p><hr>
<p>
Read sequentially:
<a href="sx5b.html" rev=precedes>prev</a>
<a href="sx5d.html" rel=precedes>next</a>
<a href="sx5.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
